4Debian.Info - Портал русскогоязычного сообщества Debian Карта сайта Контакты

Меню

Репозитории Debian

Скачать Debian

Установка Debian - Видео



Авторизация:

Новые статьи

Статьи в RSS

Новые комментарии

Новые уроки

Уроки в RSS


Вернутся к списку статей

Debian PPA

Многим пользователям Debian обидно, что ubuntu другие дистрибутивы, основанные на Debian unstable полноценно используют все прелести великого дистрибутива. В данном случае хотелось поговорить о PPA, который используется в Ubuntu.

Launchpad.net - проект был создан для разработчиков программного обеспечения, чтоб те могли не создавая отдельных репозиториев, использовать PPA (Personal Packages Archive - персональный архив пакетов), который будет содержать не одну, а все версии пакетов, которые пользователи могут сами выбрать нужную. В большей мере данный проект создан для ленивых пользователей, чтоб была возможность не искать нужные репозитории, а устанавливать их по сути в несколько кликов.

Если снять занавес, PPA(Launchpad.net) - это обычный репозиторий со стандартами Debian, а все команды работы с PPA обрабатываются с помощью специального скрипта, который добавляет нужный репозиторий в sources.list и устанавливает пакеты.

Плюсы использования PPA (Launchpad.net) в Debian
  • Нет необходимости искать репозитории необходимых пакетов.
  • Нет необходимости компилировать те пакеты, которые скомпилированы, а это большинство популярных пакетов.
  • Такая же простота установки, как и пакетов с официального репозитория.
  • Всегда доступна последняя версия пакета

Минусы использования PPA (Launchpad.net) в Debian
  • Пакеты Debian включенные в стабильную сборку проходят сложный отборочный путь, что исключает сбой в работе, внедрение вредоносного кода, ошибки несовместимости пакетов и т.д.
  • Поскольку PPA контролируют сами разработчики и никто не проводит принципиальную проверку на уязвимости или вредоносный код - потенциально это может быть опасным источником пакетов.
  • Использование PPA в Debian stable может привести к проблеме несовместимости пакета (программы) с ее зависимостями, использование так же на свой страх и риск.



Итак если Вы еще с нами, от сего следует, что Вы еще заинтересованы в использовании PPA в Debian, не буду Вас разочаровывать.


Поскольку PPA не существует в Debian и исходя из политики Debian - он там и не нужен, но мы убеждены, что наша универсальная операционная система Debian должна это уметь и точка, нам необходимо установить скрипт add-apt-repository:

bash:
  1. wget http://4debian.info/download-script/add-apt-repository -O /usr/local/sbin/add-apt-repository && chown root:root /usr/local/sbin/add-apt-repository && chmod u+x /usr/local/sbin/add-apt-repository

Код add-apt-repository:
bash:
  1. #!/bin/bash
  2. if [ $# -eq 1 ]
  3. NM=`uname -a && date`
  4. NAME=`echo $NM | md5sum | cut -f1 -d" "`
  5. then
  6. ppa_name=`echo "$1" | cut -d":" -f2 -s`
  7. if [ -z "$ppa_name" ]
  8. then
  9. echo "PPA name not found"
  10. echo "Utility to add PPA repositories in your debian machine"
  11. echo "$0 ppa:user/ppa-name"
  12. else
  13. echo "$ppa_name"
  14. echo "deb http://ppa.launchpad.net/$ppa_name/ubuntu maverick main" >> /etc/apt/sources.list
  15. apt-get update >> /dev/null | cut -d":" -f6 | cut -" " -f3 | apt-key adv --keyserver keyserver.ubuntu.com --recv-keys -
  16. fi
  17. else
  18. echo "Utility to add PPA repositories in your debian machine"
  19. echo "$0 ppa:user/ppa-name"
  20. fi


Поскольку я привожу пример с Debian squeeze (stable), для обеспечения большей совместимости, чтоб максимально оградить нас от несовместимости пакетов выбрал репозиторий для Ubuntu 10 (maverick), если Вы используете другую версию Debian или желаете использовать другую версию PPA, произведите соответствующие изменение в /usr/local/sbin/add-apt-repository в строке:
bash:
  1. echo "deb http://ppa.launchpad.net/$ppa_name/ubuntu maverick main" >> /etc/apt/sources.list

Теперь пример использования PPA для установки Firefox:
bash:
  1. add-apt-repository ppa:mozillateam/firefox-stable
  2. aptitude install firefox

Даже если и не рекомендуется использовать в Debian репозитории для Ubuntu и к тому же через PPA - это не меняет факта, что 99% пакетов буду работать как родные.

PPA Pidgin
bash:
  1. add-apt-repository ppa:ferramroberto/pidgin
  2. aptitude install pidgin

Аудиоплеер DeaDBeeF
bash:
  1. add-apt-repository ppa:alexey-smirnov/deadbeef
  2. aptitude install deadbeef

Grub Customizer менеджер настроек для GRUB2
bash:
  1. add-apt-repository ppa:danielrichter2007/grub-customizer
  2. aptitude install grub-customizer

Debian (Linux) не для ленивых и если Вы желаете работать в надежной и стабильной операционной системе, не бояться лишних уязвимостей или внедрения к Вам вредоносного кода - рекомендую не ленится все проверять и максимально контролировать обстановку!

Комментарии: Debian PPA

2013.07.26 04:11 eminymo Ссылка

Спасибо за общую конву, но что-то у меня возникло несколько проблем с вашим скриптом... Как бы то ни было, я слегка доработал и довел до работающего (у меня) вида. Если кому будет полезно, велкам:

bash:
  1. #!/bin/bash
  2.  
  3. uname -v | grep -q Debian
  4. if [ $? -ne 0 ]; then
  5. echo "Debian only. Exiting."
  6. exit 1
  7. fi
  8.  
  9. if [ $# -eq 1 ]; then
  10. ppa_name=`echo $1 | cut -d ":" -f 2`
  11. case `lsb_release --codename | awk '{ print $2 }'` in
  12. "wheezy")
  13. release="saucy"
  14. ;;
  15. *)
  16. # release="saucy"
  17. # release="raring"
  18. # release="quantal"
  19. release="precise"
  20. # release="oneiric"
  21. # release="natty"
  22. # release="maverick"
  23. # release="lucid"
  24. ;;
  25. esac
  26. if [ -z ${ppa_name} ]; then
  27. echo "PPA name not received"
  28. echo "Utility to add PPA repositories in your Debian machine"
  29. echo "Usage: $0 ppa:user/ppa-name"
  30. exit 1
  31. else
  32. echo "Processing..."
  33. echo "deb http://ppa.launchpad.net/${ppa_name}/ubuntu ${release}
  34. main" > /etc/apt/sources.list.d/`echo ${ppa_name} | tr / -`.list
  35. apt-get -qq update 2>&1 | awk -F NO_PUBKEY '{ print $2 }'
  36. | xargs apt-key adv --quiet --recv-keys
  37. --keyserver keyserver.ubuntu.com
  38. && echo "Done"
  39. || echo "PUBKEY import failed"
  40. fi
  41. else
  42. echo "Utility to add PPA repositories in your Debian machine"
  43. echo "Usage: $0 ppa:user/ppa-name"
  44. exit 1
  45. fi

2013.07.26 05:06 eminymo Ссылка

Обратите внимание, что сайт съедает символ продолжения строки - обратный слэш.

2015.03.07 16:29 uxonu Ссылка

Здравствуйте!
Как быть вот с этим :
W: Не удалось получить http://ppa.launchpad.net/blueman/ubuntu/dists/moto/main/binary-amd64/Packages 404 Not Found

W: Не удалось получить http://ppa.launchpad.net/blueman/ubuntu/dists/moto/main/binary-i386/Packages 404 Not Found

E: Некоторые индексные файлы не скачались. Они были проигнорированы или вместо них были использованы старые версии.

неподскажете?

Только авторизованные пользователи могут оставлять комментарии!

Авторизация или Быстрая регистрация



Яндекс.Метрика
4Debian.Info
При полной или частичной перепечатке текстов статей и публикаций гиперссылка на www.4debian.info обязательна. | "4Debian.Info" | © 2017